package com.crm.pay.dao.repository;

import com.crm.rely.backend.dao.repository.BaseRepository;
import com.crm.rely.backend.model.pojo.table.FinanceTrainTable;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;
import java.util.List;

/**
 * @author: houn
 */
@Repository
public interface FinanceTrainRepository extends BaseRepository<FinanceTrainTable> {

    /**
     * 根据入金流水号获取入金信息(加锁-行级锁)
     *
     * @param serial
     * @return
     */
    @Lock(LockModeType.PESSIMISTIC_WRITE)
    FinanceTrainTable findFirstBySerial(String serial);

    FinanceTrainTable getFirstBySerial(String serial);

    List<FinanceTrainTable> getAllByCustomId(Long customId);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    FinanceTrainTable findFirstById(Long id);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<FinanceTrainTable> findAllByIdIn(List<Long> ids);

    boolean existsByCustomIdAndLoginAndStatus(Long customId, Long login, Integer status);

    boolean existsByCustomIdAndLoginAndStatusIn(Long customId, Long login, List<Integer> status);
}
